#include "stdafx.h"

#include "CIMesh.h"

void CIMesh::Clear()
{
	c=Point3f(1,1,1);
	face.clear();
	vert.clear();
}

void CIMesh::ComputeFaceNormal()
{
	vector< CIFace >::iterator fi;
	for(fi=face.begin();fi!=face.end();++fi)
		(*fi).n= Normal((*fi).v[0]->p,(*fi).v[1]->p,(*fi).v[2]->p);
}

// Da chiamare solo DOPO la ComputeFaceNormal
void CIMesh::ComputeVertNormal()
{
	vector< CIFace >::iterator fi;
	for(fi=face.begin();fi!=face.end();++fi)
		for(int i=0;i<3;++i)
			(*fi).v[i]->n += (*fi).n;
}


void CIMesh::DrawPoints()
{
 glBegin(GL_POINTS);
	vector<CIVertex>::const_iterator vi;
	for(vi=vert.begin();vi!=vert.end();++vi)
	{
		glNormal((*vi).n);
		glVertex((*vi).p);
		glNormal((*vi).n);
		glVertex((*vi).p);
		glNormal((*vi).n);
		glVertex((*vi).p);
	}
	glEnd();
}


void CIShape::Sphere(CIMesh &m, const float radius, const int pl, const int md)
{
	m.Clear();
	m.vert.resize((pl+1)*(md+1));
	m.face.resize(pl*md*2);
	float plstep=180.0f/pl;
	float mdstep=360.0f/md;
  int i,j;
	int pl2=pl;
	for(i=0;i<md+1;++i){
		for(j=0;j<pl+1;++j)
		{
			float pa=ToRad(plstep*j-90.0f);// current parallel angle
			float ma=ToRad(mdstep*i);// current meridian angle
      
			Point3f p(Cos(pa)*Sin(ma),Sin(pa),Cos(pa)*Cos(ma));
			m.vert[i*(pl+1)+j].p=p*radius;
			m.vert[i*(pl+1)+j].n=p;
			m.vert[i*(pl+1)+j].t[0]=float(i)/md;
			m.vert[i*(pl+1)+j].t[1]=float(j)/pl;
		}
	}

for(i=0;i<md;++i){
	for(j=0;j<pl;++j)
		{
			m.face[(i*(pl)+j)*2+0].v[1]=&(m.vert[(i+0)*(pl+1)+(j+0)]); // a 
			m.face[(i*(pl)+j)*2+0].v[0]=&(m.vert[(i+0)*(pl+1)+(j+1)]); // b 
			m.face[(i*(pl)+j)*2+0].v[2]=&(m.vert[(i+1)*(pl+1)+(j+1)]); // d 
			
			m.face[(i*(pl)+j)*2+1].v[1]=&(m.vert[(i+0)*(pl+1)+(j+0)]); // a 
			m.face[(i*(pl)+j)*2+1].v[0]=&(m.vert[(i+1)*(pl+1)+(j+1)]); // b 
			m.face[(i*(pl)+j)*2+1].v[2]=&(m.vert[(i+1)*(pl+1)+(j+0)]); // d 
		}
	}
}